# frozen_string_literal: true

# Add your own tasks in files placed in lib/tasks ending in .rake,
# for example lib/tasks/capistrano.rake, and they will automatically be available to Rake.

require 'open3'
require_relative 'config/application'

Rails.application.load_tasks

task :serve do
  run_service 'bundle exec rails server -b 0.0.0.0'
end

def run_service(*cmd)
  Open3.popen2e(*cmd) do |_stdin, stdout_and_stderr, thread|
    begin
      stdout_and_stderr.each do |line|
        puts line
      end
    rescue SystemExit, Interrupt
      puts 'Execution iterrupted.'
    ensure
      thread.kill
    end
  end
end
